%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Problem 1 : Fixed point Iteration in Midpoint scheme
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% f: RHS of IVP
% y0 : value of solution y at current time
% y1 : value of solution y at next timestep updated by fixed point iteration
% t0 : current time value
% h : time step
% tol : error tolerance
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function y1 = ImpMidPointStep(f,y0,t0,h,tol)


% Initial estimate
f0 = ; % value of f(t,y) at t=t0
Y1 = ; % initial guess for value of y at next timestep
errNorm = norm(Y1 - y0); % error between 'current value of y' and 'updated value of y at next timestep'

% Fixed point iteration
i = 0;

while errNorm > tol

  Y1old = ; % Original value for Y1

  Y1 = ; % Updated value for Y1

  errNorm = norm(Y1 - Y1old);


  i = i+1;
  if(i>=1e5)
    fprintf('Fixed point iteration terminated after %d steps with error %g\n',i,errNorm);
    break
  end
end

% Define solution and feval at next timestep
y1 = Y1;


return
